﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Chbl.Models;

namespace Chbl.Controllers
{ 
    public class TestController : Controller
    {
        private ChblDb db = new ChblDb();

        //
        // GET: /Test/

        public ViewResult Index()
        {
            return View(db.Teams.ToList());
        }

        //
        // GET: /Test/Details/5

        public ViewResult Details(int id)
        {
            Team team = db.Teams.Find(id);
            return View(team);
        }

        //
        // GET: /Test/Create

        public ActionResult Create()
        {
            ViewBag.Divisions = db.Divisions.ToList();
            return View();
        } 

        //
        // POST: /Test/Create

        [HttpPost]
        public ActionResult Create(Team team)
        {
            if (ModelState.IsValid)
            {
                db.Teams.Add(team);
                db.SaveChanges();
                return RedirectToAction("Index");  
            }

            return View(team);
        }
        
        //
        // GET: /Test/Edit/5
 
        public ActionResult Edit(int id)
        {
            Team team = db.Teams.Find(id);
            return View(team);
        }

        //
        // POST: /Test/Edit/5

        [HttpPost]
        public ActionResult Edit(Team team)
        {
            if (ModelState.IsValid)
            {
                db.Entry(team).State = EntityState.Modified;
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(team);
        }

        //
        // GET: /Test/Delete/5
 
        public ActionResult Delete(int id)
        {
            Team team = db.Teams.Find(id);
            return View(team);
        }

        //
        // POST: /Test/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(int id)
        {            
            Team team = db.Teams.Find(id);
            db.Teams.Remove(team);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}