﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Chbl.Models
{
    public class Article
    {
        public int ArticleId { get; set; }

        [Required]
        [MinLength(1)]
        [DataType(DataType.Text)]
        [Display(Name = "Заголовок")]
        public string Title { get; set; }

        [Required]
        [DataType(DataType.Url)]
        [Display(Name = "Изображение на главной странице")]
        public string BigImageUrl { get; set; }
        
        [Required]
        [DataType(DataType.Url)]
        [Display(Name = "Изображение на главной странице в галерии")]
        public string SmallImageUrl { get; set; }
        
        [Required]
        [DataType(DataType.Html)]
        [AllowHtml]
        [MaxLength(10000)]
        [Display(Name = "Содержание")]
        public string Content { get; set; }

        [DataType(DataType.Text)]
        [Display(Name = "Автор")]
        public string Author { get; set; }
        
        [Display(Name = "Дата создания")]
        [DataType(DataType.Date)]
        public DateTime Date { get; set; }

        [Required]
        [Display(Name = "Разместить на главной странице?")]
        public bool isTopNews { get; set; }

        [Required]
        [Display(Name = "Порядок новости на главной странице")]
        [Range(1, 3, ErrorMessage = "Корректный номер новости 1..3")]
        public int TopNewsNumber { get; set; }

    }
}